 /*
 * file      : src/callbacks.h
 * project   : tm
 * with      : Gtk-2
 *
 * copyright : (C) 2012 by Claude BULIN
 *
 * TM - Edition des heures de travail / Edition of working hours
 * GNU General Public License
 * 
 * This file is part of TM.
 * 
 * TM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 * 
 * TM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with TM.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef __callbacks_h__
#define __callbacks_h__ 1


// 
// La definition SCALE_MIN correspond au pourcentage de representation le plus petit de l'image de fond
// SCALE_MIN doit etre adaptee suivant la taille la plus petite de la fenetre
// 
#define SCALE_MIN		0.2
// 
// Definition d'un millimetre
// Formule employee en PostScript
// 
#define MM(x)(((gdouble)x * 72.0) / 25.4 )
// 
// Points pour 1 millimetre
// 
#define POINTS_PER_MM    2.83464566929
// 
// Taille de la structure VAR_EDIT_DAY *DayAdjust
// 
#define MAX_DAY_ADJUST 10
// 
// Espace entre deux lignes
// 
#define _POS_LINE_Y_ ((gdouble)VarDraw.SizeFontName + 7.0)
// 
// Position de la ligne en debut de page
// 
#define _POS_LINE_Y_BEGIN_PAGE_ (_POS_LINE_Y_ + 4.0)
// 
// Taille d'une page
// 
#define _SIZE_ONE_PAGE_ ((gdouble)VarDraw.image_height / (gdouble)VarDraw.TotalPages)
// 
// 
// 
#define _VALUE_ 0.15

// 
// CALLBACKS.C
// 
typedef struct {

	GtkWidget	*Adr_YearActivate;			// 
	GtkWidget	*Adr_spinbutton_matin_debut_h;		// 
	GtkWidget	*Adr_spinbutton_matin_debut_mn;		// 
	GtkWidget	*Adr_spinbutton_matin_fin_h;		// 
	GtkWidget	*Adr_spinbutton_matin_fin_mn;		// 
	GtkWidget	*Adr_spinbutton_soir_debut_h;		// 
	GtkWidget	*Adr_spinbutton_soir_debut_mn;		// 
	GtkWidget	*Adr_spinbutton_soir_fin_h;		// 
	GtkWidget	*Adr_spinbutton_soir_fin_mn;		// 
	GtkWidget	*Adr_textview;				// 
	GtkWidget	*Adr_spinbutton_time_by_week_h;		// 
	GtkWidget	*Adr_spinbutton_time_by_week_mn;	// 
	GtkCalendar	*Adr_Calendar;				// 
	
} VAR_CALLBACKS;

extern VAR_CALLBACKS	VarCallbacks;

typedef struct {
	
	GtkWidget	*AdrDrawingarea;			// Adresse de la surface
	cairo_surface_t	*image;					// Adresse de l'image
	gint		image_width;				// Width
	gint		image_height;				// Height
	gdouble		scale;					// Pourcentage de surface de l'image
	gdouble		x0;					// Pos X
	gdouble		y0;					// Pos Y
	gboolean	BoolScaleAdjust;			// TRUE = ajustement de l'echelle avec la surface de la fentre
	gboolean	BoolSaveToFile;				// TRUE si sauvegarde vers fichier
	void		(*FuncExtern)( void );			// 
	gint		TotalPages;				// Nombre total de pages
	gchar		*FontName;				// Nom de la fonte
	gdouble		SizeFontName;				// Taille de la fonte
	gdouble		SizeFontTitle;				// Taille de la fonte
	
} VAR_DRAW;

extern VAR_DRAW VarDraw;

typedef enum {
	FORCE_SAVE_FILE = 0,					// 
	NO_FORCE_SAVE_FILE					// 
} SAVE_FILE_TYPE;

typedef struct {
	gint		IndiceJour;				// Indice du jour: 0 .. NbrJoursAnnee
	gint		ThisDay;				// 1=LUNDI .. 7=DIMANCHE
	gint		Day;					// 
	gint		Month;					// 
	gint		MatinDebut;				// Debut heure de travail en minutes
	gint		MatinFin;				// Fin heure travail en minutes
	gint		SoirDebut;				// Debut heure de repas en minutes
	gint		SoirFin;				// Fin heure de repas en minutes
	gint		WorkingTime;				// Heures de la semaine stockees le dimanche
	gint		OverTime;				// Heures superieures a HEURES_NORMALES_SEMAINE stockees le dimanche
	GString		*LongComment;				// Commentaire
} VAR_EDIT_DAY;

typedef struct {
	gboolean	BoolReady;				// It's ready to edit
	gboolean	BoolEdit;				// TRUE IF edit
	gboolean	BoolChanged;				// If TRUE then CALL: EditYear_spinbutton_time_value_changed()
	guint		YearEdit;				// Annee actuelle en edition
	gint		NbrJoursAnnee;				// Total jours par an
	gint		DayOfYear;				// Jour de l'annee ou -1
	gchar		**Larrbuf;				// Buffer file datas
	VAR_EDIT_DAY	*Day;					// (VAR_EDIT_DAY *)g_malloc0( sizeof(VAR_EDIT_DAY) * VarEdit.NbrJoursAnnee )
	VAR_EDIT_DAY	*DayAdjust;				// 
} VAR_EDIT;

extern VAR_EDIT VarEdit;

typedef enum {
	NOUVELLE_PAGE = 0,
	STRING,
	STRING_REPAIR,
	STRING_COMMENT,
	STRING_PAGE,
	LINE_GRAPH
} LINE_TYPE;

typedef enum {
	COLOR_WHITE = 0,					// 	1.0	1.0	1.0
	COLOR_BLACK,						// 	0.0	0.0	0.0
	COLOR_RED,						// 	1.0	0.0	0.0
	COLOR_GREEN,						// 	0.0	1.0	0.0
	COLOR_BLUE,						// 	0.0	0.0	1.0
	COLOR_YELLOW,						//	1.0	1.0	0.0
	COLOR_GRIS,						//	0.5	0.5	0.5
	COLOR_MAGENTA,						//	0.5	0.0	0.5
	COLOR_ORANGE,						//	1.0	0.5	0.0
	COLOR_BLEU_FONCE					//	0.0	0.0	0.8
} TYPE_COLOR;

typedef enum {
	FONT_SLANT_NORMAL = 0,					// 
	FONT_SLANT_ITALIC					// 
} FONT_SLANT_TYPE;

typedef enum {
	FONT_WEIGHT_NORMAL = 0,					// 
	FONT_WEIGHT_BOLD					// 
} FONT_WEIGHT_TYPE;

typedef struct {
	LINE_TYPE		LineType;			// 
	gdouble			PosX, PosY;			// 
	gdouble			PosXPS, PosYPS;			// 
	gdouble			PosXLine;			// 
	TYPE_COLOR		TypeColor;			// 
	FONT_SLANT_TYPE		FontSlantType;			// 
	FONT_WEIGHT_TYPE	FontWeightType;			// 
	gchar			*Str;				// 
	gdouble			LenStr;
	gdouble			SizeFont;			// 
	// LINE
	gdouble			LinePosX, LinePosY, LineLen;	// 
} LINE_OF_PAGE;

typedef struct {						// DETAILS POUR UNE LIGNE
	GList	*LineDetail;					// struct LINE_OF_PAGE
} LINE;

typedef struct {						// TOUTES LE PAGES
	gint	NbrPages;					// Nombre total de pages
	GList	*Page;						// struct LINE
} ALL_PAGES;

extern ALL_PAGES AllPages;

void		page_list_remove( void );
void		page_create( void );
void		page_list_alloc( LINE_TYPE p_LineType );
void		page_add_PosX( gdouble p_PosX );
gdouble		page_add_PosY( gdouble p_PosY );
void		page_add_PosXLine( gdouble p_PosXLine );
void		page_add_font_color( TYPE_COLOR p_TypeColor );
void		page_add_font_slant( FONT_SLANT_TYPE p_FontSlantType );
void		page_add_font_weight( FONT_WEIGHT_TYPE p_FontWeightType );
void		page_add_str( gchar *p_Str );
void		page_add_line( gdouble p_LinePosX, gdouble p_LinePosY, gdouble p_LineLen );
void		page_search_posX_ps( void );

void		callbacks_button_open_year( gchar *p_path );
void		callbacks_alloc_page( gint p_TotalPages );

void		draw_paint( cairo_surface_t *p_cs );
gdouble		draw_get_scale_adjust( void );
void		draw_year( void );
void		draw_set_size_request( void );

void		file_save_struct( SAVE_FILE_TYPE p_TypeFileSave );
gboolean	file_read( gchar *p_PathNameFileBase );
void		file_remove_struct_year( void );
void		file_remove_struct_all( void );
gint		file_make_list( void );
void		file_alloc_struct( void );

void		edit_set_flag_buttons( void );
void		edit_set_pathnamefile( gchar *PathNameFile );
gchar		*edit_get_namefile( gchar *p_PathNameFile );
gint		edit_select_new_year( void );
void		edit_set_datas_to_spinbuttons( guint p_DayOfYear );
void		edit_set_textview( gchar *Str );
void		edit_get_DayAdjust( gint p_ind, gint *p_MatinDebut, gint *p_MatinFin, gint *p_SoirDebut, gint *p_SoirFin, gchar **p_Comment );
void		edit_set_DayAdjust( gint p_ind, gint p_MatinDebut, gint p_MatinFin, gint p_SoirDebut, gint p_SoirFin, gchar *p_Comment );
void		edit_apply_weeks( gint p_IndMonth );

void		export_file( void );

#endif





