 /*
 * file      : src/global.h
 * project   : tm
 * with      : Gtk-2
 *
 * copyright : (C) 2012 by Claude BULIN
 *
 * TM - Edition des heures de travail / Edition of working hours
 * GNU General Public License
 * 
 * This file is part of TM.
 * 
 * TM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 * 
 * TM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with TM.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef __global_h__
#define __global_h__ 1

extern	GtkBuilder	*GtkBuilderProjet;
extern	GtkWidget	*WindMain;

#define GLADE_GET_OBJECT(OBJ) gtk_builder_get_object (GtkBuilderProjet, OBJ)

/*
*---------------------------------------------------------------------------
* DEBUG
*---------------------------------------------------------------------------
*/
#define PRINT_FUNC_LF() if( TRUE == OptionsCommandLine.BoolVerboseMode ) g_print ("%s :: %s (line = %d)\n", __FILE__, __FUNCTION__, __LINE__)
#define PRINTINT(str,num) g_print ("%s = %d\n", str, num)
#define PRINTBOOL(str,bool) g_print ("%s = %s\n", str, bool == TRUE ? "TRUE" : "FALSE")
#define PRINT(str) if( TRUE == OptionsCommandLine.BoolVerboseMode ) g_print ("%s :: %s(line = %d)\n\t%s\n", __FILE__, __FUNCTION__, __LINE__, str)
#define VERBOSE(str) if( TRUE == OptionsCommandLine.BoolVerboseMode ) g_print( "%s", str );

/*
*---------------------------------------------------------------------------
* SUPPORT
*---------------------------------------------------------------------------
*/
#ifndef GLADE_HOOKUP_OBJECT
#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)
#endif

#ifndef GLADE_HOOKUP_OBJECT_NO_REF
#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)
#endif


// /usr/include/gtk-2.0/gdk/gdkkeysyms.h
typedef struct {
	gboolean	BoolGDKPress;		// 
	gboolean	BoolGDK_Control_L_R;	// 
	gboolean	BoolGDK_Control_A;	// 
	gboolean	BoolGDK_Shift_L_R;	// 
	gboolean	BoolGDK_Shift_L;	// 
	gboolean	BoolGDK_Shift_R;	// 
	guint		keyval;			// 
} KEYS;


#define CHECKBUTTON_JANVIER	1
#define CHECKBUTTON_FEVRIER	2
#define CHECKBUTTON_MARS	4
#define CHECKBUTTON_AVRIL	8
#define CHECKBUTTON_MAI		16
#define CHECKBUTTON_JUIN	32
#define CHECKBUTTON_JUILLET	64
#define CHECKBUTTON_AOUT	128
#define CHECKBUTTON_SEPTEMBRE	256
#define CHECKBUTTON_OCTOBRE	512
#define CHECKBUTTON_NOVEMBRE	1024
#define CHECKBUTTON_DECEMBRE	2048

#define CHECKBUTTON_PDF		1
#define CHECKBUTTON_PNG		2
#define CHECKBUTTON_PS		4
#define CHECKBUTTON_TXT		8

#endif

